<template>
  <div class="loading">
    <div class="circle"></div>
    <span class="message">{{messages[messageIndex]}}</span>
  </div>
</template>

<script>
export default {
  name: 'loading',
  data() {
    return {
      interval: null,
      messages: [
        'Analyzing facial features...',
        'Checking hair to face ratio...',
        'This is my life now...',
        'Please don\'t make me do this...',
        'Testing for mental fitness...',
        'Detecting intelligent life...',
        'Detecting unintelligent life...'
      ],
      messageIndex: 0
    }
  },
  methods: {
    shuffle(array) {
      let copy = [...array]
      let counter = copy.length

      while (counter > 0) {
        let index = Math.floor(Math.random() * counter)

        counter--

        let temp = copy[counter]
        copy[counter] = copy[index]
        copy[index] = temp
      }

      return copy
    }
  },
  mounted() {
    this.interval = setInterval(() => {
      if (this.messageIndex < this.messages.length - 1) {
        this.messageIndex = this.messageIndex + 1
      } else {
        this.messages = this.shuffle(this.messages)
        this.messageIndex = 0
      }
    }, Math.floor(Math.random() + 2) * 1000)
  },
  destroyed() {
    this.interval = null
  },
  created() {
    this.messages = this.shuffle(this.messages)
  }
}
</script>

<style lang="scss" scoped>
@import '../config.scss';

@keyframes inner {
  0% {
    transform: translateX(-300%) scale(0);
  }

  25% {
    transform: translateX(-150%) scale(0.5);
  }

  50% {
    transform: translateX(0%) scale(1);
  }

  75% {
    transform: translateX(150%) scale(0.5);
  }

  100% {
    transform: translateX(300%) scale(0);
  }
}

.message {
  font-size: 14px;
  font-weight: 500;
  color: $dark-grey;
}

.loading {
  text-align: center;
  width: 100%;
  height: 38px;
  position: relative;
}

.circle {
  position: absolute;
  margin: 0 auto;
  width: 38px;
  height: 38px;
  border-radius: 50%;
  background-color: rgba($orange, 0.2);
  animation-name: inner;
  animation-duration: 2s;
  animation-iteration-count: infinite;
  animation-timing-function: linear;

  &::before {
    position: absolute;
    background-color: rgba($orange, 0.4);
    display: block;
    content: '';
    width: 38px;
    height: 38px;
    border-radius: 50%;
    animation-name: inner;
    animation-duration: 2s;
    animation-iteration-count: infinite;
    animation-direction: reverse;
  }

  &::after {
    position: absolute;
    background-color: rgba($orange, 0.2);
    display: block;
    content: '';
    width: 38px;
    height: 38px;
    border-radius: 50%;
    animation-name: inner;
    animation-duration: 3s;
    animation-iteration-count: infinite;
    animation-direction: alternate;
  }
}
</style>
